% CREDITS: University of Bologna
% Author:  Giovanni Mariotta
            
%This software is used to evaluete the Green Fluorescence Mean in a
%bacteria population by picture from microscope.

function varargout = classificazione(varargin)

%Initialization GUI

gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @classificazione_OpeningFcn, ...
                   'gui_OutputFcn',  @classificazione_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
               
               

                  
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end



% --- Executes just before classificazione is made visible.
function classificazione_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);

function varargout = classificazione_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;






% --- Executes during object creation, after setting all properties.
function pushbutton3_CreateFcn(hObject, eventdata, handles)
evalin('base','clc')
evalin('base','clear all')



% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)

evalin('base','clc');
evalin('base','clear all');

%gets input file(s) from user
[input_file,pathname] = uigetfile( ...
       {'*.jpg', 'Jpeg (*.jpg)'; ...
        '*.bmp', 'BitMap (*.bmp)'; ...       
        '*.*', 'All Files (*.*)'}, ...
        'Select files', ... 
        'MultiSelect', 'on');
   
%if file selection is cancelled, pathname should be zero
%and nothing should happen
if pathname == 0
    return
    inputFileNames = get(handles.inputFiles_listbox,'String')

end
     
   set(handles.text_NomeFile, 'String',input_file)
   RGB_visual = imread(input_file);
   
   axes(handles.axes1);
   imshow(RGB_visual); 
   
   assignin('base','nomefile',input_file);
   assignin('base','RGB',RGB_visual);
   assignin('base','RGB_color_changed','0');
   
   set(handles.checkbox4,'Enable','on');
   set(handles.checkbox5,'Enable','on');
   set(handles.checkbox6,'Enable','on');
   set(handles.checkbox7,'Enable','on');
   set(handles.checkbox7,'Value',1);
   set(handles.checkbox8,'Enable','off');
   set(handles.pushbutton9,'Enable','on');
   set(handles.pushbutton8,'Enable','on');

  
   
   
   
   
function pushbutton4_Callback(hObject, eventdata, handles)

%---------------------------------------------------------
%             PROGRAMMA ELABORAZIONE IMMAGINI
%---------------------------------------------------------
   set(handles.text1_R, 'String', 0)
   set(handles.text2_R, 'String', 0)
   set(handles.text3_R, 'String', 0)
   set(handles.text4_R, 'String', 0)
   set(handles.text5_R, 'String', 0)
   set(handles.text6_R, 'String', 0)
   set(handles.text7_R, 'String', 0)
   
classificazioneFluor;


%function pushbutton4_ButtonDownFcn(hObject, eventdata, handles)


% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)







% --- Executes on slider movement.
function slider3_Callback(hObject, eventdata, handles)
t = get(handles.slider3,'value');
set(handles.text_Soglia_Focus,'String',num2str(t));



% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider6_Callback(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider4_Callback(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
t = get(handles.slider4,'value');
set(handles.text_Area_Min_Prescelta,'String',(num2str(t)));



% --- Executes during object creation, after setting all properties.
function slider4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider5_Callback(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
t = get(handles.slider5,'value');
set(handles.text_Area_Max_Prescelta,'String',(num2str(t)));


% --- Executes during object creation, after setting all properties.
function slider5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)

classificazioneFluor;

% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function text_Limite_Inferiore_Alg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_Limite_Inferiore_Alg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function axes2_CreateFcn(hObject, eventdata, handles)




% hObject    handle to axes2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes2


% --- Executes during object creation, after setting all properties.
function axes3_CreateFcn(hObject, eventdata, handles)



% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes3


% --- Executes during object creation, after setting all properties.
function text_NomeFile_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text_NomeFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)

assignin('base','stop_var',1);


% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axes1_CreateFcn(hObject, eventdata, handles)


   
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)



% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function pushbutton4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object deletion, before destroying properties.
function axes2_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to axes2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axis1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes1


% --- Executes during object creation, after setting all properties.
function axes4_CreateFcn(hObject, eventdata, handles)
logo=imread('logounibo.jpg');
imshow(logo);

% hObject    handle to axes4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes4


% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
set(handles.checkbox8,'Enable','on')
bacteria_detail

set(handles.checkbox4,'Value',0)
set(handles.checkbox5,'Value',0)
set(handles.checkbox6,'Value',0)
set(handles.checkbox7,'Value',0)


set(handles.checkbox4,'Enable','off')
set(handles.checkbox5,'Enable','off')
set(handles.checkbox6,'Enable','off')
set(handles.checkbox7,'Enable','off')



% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton4.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on slider movement.
function slider11_Callback(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function slider11_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in pushbutton8.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)

RGB_color=evalin('base','RGB(:,:,2);');
assignin('base','RGB_color',RGB_color);

if (get(hObject,'Value') == get(hObject,'Max'))
   % Checkbox is checked-take approriate action
   
   set(handles.checkbox5,'Enable','off');
   set(handles.checkbox6,'Enable','off');
   set(handles.checkbox7,'Enable','off');
     
   RGB_color_changed=evalin('base','RGB_color_changed;');
  
            RGB_color=evalin('base','RGB(:,:,1);');
            axes(handles.axes1);
            imshow(RGB_color);
        
   
         
else
   % Checkbox is not checked-take approriate action
   set(handles.checkbox5,'Enable','on');
   set(handles.checkbox6,'Enable','on');
   set(handles.checkbox7,'Enable','on');
   
   
   
   if get(handles.checkbox7,'Value')==1
   
   axes(handles.axes1)
   RGB=evalin('base','RGB');
   imshow(RGB);
   
   else
       
   axes(handles.axes1)
   black=imread('black_im.jpg');
   imshow(black)
   end   
  
end


% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4


% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)

RGB_color=evalin('base','RGB(:,:,2);');
assignin('base','RGB_color',RGB_color);



if (get(hObject,'Value') == get(hObject,'Max'))
   % Checkbox is checked-take approriate action
   
   set(handles.checkbox4,'Enable','off');
   set(handles.checkbox6,'Enable','off');
   set(handles.checkbox7,'Enable','off');
     
   RGB_color_changed=evalin('base','RGB_color_changed;');
  
            
            RGB_color=evalin('base','RGB(:,:,2);');
            axes(handles.axes1);
            imshow(RGB_color);
           
else
   % Checkbox is not checked-take approriate action
   set(handles.checkbox4,'Enable','on');
   set(handles.checkbox6,'Enable','on');
   set(handles.checkbox7,'Enable','on');
   
  if get(handles.checkbox7,'Value')==1
   
   axes(handles.axes1)
   RGB=evalin('base','RGB');
   imshow(RGB);
   
   else
       
   axes(handles.axes1)
   black=imread('black_im.jpg');
   imshow(black)
   end   

end

% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox5


% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)

RGB_color=evalin('base','RGB(:,:,2);');
assignin('base','RGB_color',RGB_color);


if (get(hObject,'Value') == get(hObject,'Max'))
   % Checkbox is checked-take approriate action
   
   set(handles.checkbox4,'Enable','off');
   set(handles.checkbox5,'Enable','off');
   set(handles.checkbox7,'Enable','off');
   
   RGB_color_changed=evalin('base','RGB_color_changed;');
  
   RGB_color=evalin('base','RGB(:,:,3);');
   axes(handles.axes1);
   imshow(RGB_color);
       
   
else
   % Checkbox is not checked-take approriate action
   set(handles.checkbox4,'Enable','on');
   set(handles.checkbox5,'Enable','on');
   set(handles.checkbox7,'Enable','on');
   
  if get(handles.checkbox7,'Value')==1
   
   axes(handles.axes1)
   RGB=evalin('base','RGB');
   imshow(RGB);
   
   else
       
   axes(handles.axes1)
   black=imread('black_im.jpg');
   imshow(black)
   end   
   
end

% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox6


% --- Executes during object creation, after setting all properties.
function pushbutton10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in checkbox7.
function checkbox7_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox7
if (get(hObject,'Value') == get(hObject,'Max'))
   % Checkbox is checked-take approriate action
   set(handles.checkbox4,'Enable','off');
   set(handles.checkbox5,'Enable','off');
   set(handles.checkbox6,'Enable','off');
   set(handles.checkbox8,'Enable','off');
   RGB=evalin('base','RGB');
   axes(handles.axes1);
   imshow(RGB);
   
   set(handles.checkbox4,'Value',0);
   set(handles.checkbox5,'Value',0);
   set(handles.checkbox6,'Value',0);
   set(handles.checkbox8,'Value',0);
 
   
else
   % Checkbox is not checked-take approriate action
   set(handles.checkbox4,'Enable','on');
   set(handles.checkbox5,'Enable','on');
   set(handles.checkbox6,'Enable','on');
   set(handles.checkbox7,'Enable','on');
   black_im=imread('black_im.jpg');
   axes(handles.axes1)
   imshow(black_im)
   
RGB_color_changed=evalin('base','RGB_color_changed;');
   if RGB_color_changed==1
       set(handles.checkbox8,'Enable','on')
   end
   
   end


% --- Executes during object creation, after setting all properties.
function checkbox4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in checkbox8.
function checkbox8_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox8

RGB_color_changed=evalin('base','RGB_color_changed');
    
if (get(hObject,'Value') == get(hObject,'Max'))
    
    set(handles.checkbox4,'Enable','off');
    set(handles.checkbox5,'Enable','off');
    set(handles.checkbox6,'Enable','off');
    set(handles.checkbox7,'Enable','off');
   
    set(handles.checkbox4,'Value',0);
    set(handles.checkbox5,'Value',0);
    set(handles.checkbox6,'Value',0);
    set(handles.checkbox7,'Value',0);
    
    if RGB_color_changed==1
            RGB_color=evalin('base','RGB_color');
            axes(handles.axes1)
            imshow(RGB_color)
        else
        end
        
else
    
    black_im=imread('black_im.jpg');
    axes(handles.axes1)
    imshow(black_im);
    set(handles.checkbox4,'Enable','on');
    set(handles.checkbox5,'Enable','on');
    set(handles.checkbox6,'Enable','on');
    set(handles.checkbox7,'Enable','on');   
    
end


% --- Executes during object creation, after setting all properties.
function checkbox8_CreateFcn(hObject, eventdata, handles)



% hObject    handle to checkbox8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object deletion, before destroying properties.
function checkbox4_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function checkbox5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


